/*

*/

#pragma semicolon 1
#define PLUGIN_VERSION "1.0.1"
#define LoopValidPlayers(%1)						for(int %1 = 1; %1 <= MaxClients; %1++)		if(IsValidClient(%1))

#include <sourcemod>
#include <autoexecconfig>	//https://github.com/Impact123/AutoExecConfig or https://forums.alliedmods.net/showthread.php?p=1862459
#include <sdkhooks>
#include <sdktools>

#pragma newdecls required

ConVar g_cSpawnProtection = null;

int ga_iSpawnProtValidation[MAXPLAYERS + 1] = {0, ...};
bool ga_bSpawnProtection[MAXPLAYERS + 1] = {false, ...};

bool g_bLateLoad = false;

public Plugin myinfo =
{
	name = "TOG Spawn Protection",
	author = "That One Guy",
	description = "Configurable spawn protection module",
	version = PLUGIN_VERSION,
	url = "https://www.togcoding.com/togcoding/"
}

public APLRes AskPluginLoad2(Handle hMyself, bool bLate, char[] sError, int err_max)
{
	g_bLateLoad = bLate;
	return APLRes_Success;
}

public void OnPluginStart()
{
	AutoExecConfig_SetFile("togspawnprotection");
	AutoExecConfig_CreateConVar("togspawnprotection_version", PLUGIN_VERSION, "TOG Spawn Protection version number.", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	g_cSpawnProtection = AutoExecConfig_CreateConVar("spawnprotection_duration", "4.0", "Number of seconds to enable spawn protection during warmup (0 = disabled).", FCVAR_NONE, true, 0.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	HookEvent("bullet_impact", Event_BulletImpact);
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath, EventHookMode_Post);
}

public void OnConfigsExecuted()
{
	if(g_bLateLoad)
	{
		LoopValidPlayers(i)
		{
			OnClientPutInServer(i);
		}
	}
}

public void OnClientPutInServer(int client)
{
	ga_iSpawnProtValidation[client] = 0;
	ga_bSpawnProtection[client] = false;
	SDKHook(client, SDKHook_OnTakeDamage, Event_OnTakeDamage);
}

public void OnClientDisconnect(int client)
{
	ga_iSpawnProtValidation[client] = 0;
	ga_bSpawnProtection[client] = false;
}

public Action Event_PlayerSpawn(Event hEvent, const char[] sName, bool bDontBroadcast)
{
	int client = GetClientOfUserId(hEvent.GetInt("userid"));
	if(!IsValidClient(client))
	{
		return Plugin_Continue;
	}
	
	if(g_cSpawnProtection.FloatValue)
	{
		Handle hData = CreateDataPack();
		WritePackCell(hData, GetClientUserId(client));
		WritePackCell(hData, ga_iSpawnProtValidation[client]);
		ResetPack(hData);
		CreateTimer(g_cSpawnProtection.FloatValue, TimerCB_DisableSpawnProtection, hData);
		ga_bSpawnProtection[client] = true;
		SetClientVisibility(client, 200);
	}
	
	return Plugin_Continue;
}

public Action Event_PlayerDeath(Event hEvent, const char[] sName, bool bDontBroadcast)
{
	int victim = GetClientOfUserId(hEvent.GetInt("userid"));
	ga_iSpawnProtValidation[victim]++;
}

void OnPluginEnd()
{
	LoopValidPlayers(i)
	{
		SetClientVisibility(i, 255);
	}
}

void SetClientVisibility(int client, int iAmmount, bool bWeapon = true)
{
	RenderMode iRenderMode = RENDER_NORMAL;
	if(iAmmount != 255)
	{
		iRenderMode = RENDER_GLOW;
	}
	
	if(IsValidEntity(client))
	{
		SetEntityRenderMode(client, iRenderMode);
		SetEntityRenderColor(client, 255, 255, 255, iAmmount);
	}
	
	if(bWeapon)
	{
		int iWeapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
		if(IsValidEntity(iWeapon) && iWeapon != -1)
		{
			SetEntityRenderMode(iWeapon, iRenderMode);
			SetEntityRenderColor(iWeapon, 255, 255, 255, iAmmount);
			int iWeapon2;
			for(int j; j < 5; j++)
			{
				if((iWeapon2 = GetPlayerWeaponSlot(client, j)) != -1 && IsValidEntity(iWeapon2))
				{
					SetEntityRenderMode(iWeapon2, iRenderMode);
					SetEntityRenderColor(iWeapon2, 255, 255, 255, iAmmount);
				}
			}
		}
	}
}

public Action Event_OnTakeDamage(int victim, int &attacker, int &inflictor, float &fDamage, int &damagetype, int &weapon, float a_fDmgForce[3], float a_fDmgPosition[3]/*, int damagecustom*/)
{
	if(IsValidClient(victim))
	{
		if(ga_bSpawnProtection[victim])
		{
			fDamage = 0.0;
			return Plugin_Changed;
		}
	}
	
	return Plugin_Continue;
}

public Action Event_BulletImpact(Event hEvent, const char[] sName, bool bDontBroadcast)	//using this instead of weapon fire event so that knife and nades are ignored
{
	if(!g_cSpawnProtection.FloatValue)
	{
		return Plugin_Continue;
	}
	
	int client = GetClientOfUserId(hEvent.GetInt("userid"));
	if(IsValidClient(client))
	{
		ga_bSpawnProtection[client] = false;
		Handle hData = CreateDataPack();
		WritePackCell(hData, GetClientUserId(client));
		WritePackCell(hData, ga_iSpawnProtValidation[client]);
		ResetPack(hData);
		CreateTimer(0.1, TimerCB_DisableSpawnProtection, hData);
	}

	return Plugin_Continue;
}

public Action TimerCB_DisableSpawnProtection(Handle hTimer, any hData)
{
	int client = GetClientOfUserId(ReadPackCell(hData));
	int iValidation = ReadPackCell(hData);
	CloseHandle(hData);
	if(IsValidClient(client))
	{
		if(iValidation == ga_iSpawnProtValidation[client])
		{
			ga_bSpawnProtection[client] = false;
			SetClientVisibility(client, 255);
		}
	}
}

bool IsValidClient(int client/*, bool bAllowBots = false, bool bAllowDead = true*/)
{
	if(!(1 <= client <= MaxClients) || !IsClientInGame(client) /*|| (IsFakeClient(client) && !bAllowBots) || (!IsPlayerAlive(client) && !bAllowDead) || IsClientSourceTV(client) || IsClientReplay(client)*/)
	{
		return false;
	}
	return true;
}

stock void Log(char[] sPath, const char[] sMsg, any ...)		//TOG logging function - path is relative to logs folder.
{
	char sLogFilePath[PLATFORM_MAX_PATH], sFormattedMsg[1500];
	BuildPath(Path_SM, sLogFilePath, sizeof(sLogFilePath), "logs/%s", sPath);
	VFormat(sFormattedMsg, sizeof(sFormattedMsg), sMsg, 3);
	LogToFileEx(sLogFilePath, "%s", sFormattedMsg);
}

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////// CHANGE LOG //////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/*
	1.0.0
		* Initial creation.
	1.0.1
		* Added missing hook on player for take dmg.
	1.0.2
		* Added setting back visibility to normal in OnPluginEnd.
		
*/