<?php
	if(!function_exists('GetSteamID64'))
	{
		function GetSteamID64($steamid)
		{
			if(preg_match('/^STEAM_[0-9]:[0-9]:[0-9]{1,}/i', $steamid))	// Valid?
			{
				// Convert
				$steamid = str_replace("_", ":", $steamid);
				list($part_one, $part_two, $part_three, $part_four) = explode(':', $steamid);
				$result = bcadd('76561197960265728', $part_four * 2);
				return bcadd($result, $part_three);
			}
			else 
			{
				return false;
			}
		}
	}
	
	if(!function_exists('noHTML'))
	{	
		function noHTML($input, $encoding = 'UTF-8')
		{
			return htmlentities($input, ENT_QUOTES | ENT_HTML5, $encoding);
		}
	}
	
	if(!function_exists('console_log'))
	{
		function console_log($data, $sLabel = "")
		{
			echo '<script>console.log('.json_encode($sLabel.": ".$data).')</script>';
		}
	}
	
	if(!function_exists('SearchBox'))
	{
		function SearchBox($name, $text, $classtop, $classright = "right0")
		{
			echo '<div class="infobox2 posfixed '.$classtop.' '.$classright.'">';
				echo '<input type="text" placeholder="'.$text.'" name="nm'.$name.'" id="id'.$name.'">';
			echo '</div>';
		}
	}
	
	if(!function_exists('AddRedirectBtn'))
	{
		function AddRedirectBtn($url, $label)
		{
			echo '<button class="redirectbtn" name="'.$url.'">'.$label.'</button>';
		}
	}
	
	if(!function_exists('GetColArrayData'))
	{
		function GetColArrayData($sGlobalArrName, $sFieldNameOrHeader, $index, $default)
		{
			for($i = 0; $i < count($GLOBALS[$sGlobalArrName]); $i++)
			{
				$a_sField = $GLOBALS[$sGlobalArrName][$i];
				if((strtoupper($a_sField[0]) == strtoupper($sFieldNameOrHeader)) || (strtoupper($a_sField[1]) == strtoupper($sFieldNameOrHeader)))
				{
					return $a_sField[$index];
				}
			}
			return $default;
		}
	}
	
	if(!function_exists('CheckIfValidColumn'))
	{
		function CheckIfValidColumn($sGlobalArrName, $sFieldName, $return_nomatch)
		{
			for($i = 0; $i < count($GLOBALS[$sGlobalArrName]); $i++)
			{
				$a_sField = $GLOBALS[$sGlobalArrName][$i];
				if((strtoupper($a_sField[0]) == strtoupper($sFieldName)) || (strtoupper($a_sField[1]) == strtoupper($sFieldName)))
				{
					return $sFieldName;
				}
			}
			return $return_nomatch;
		}
	}

	if(!function_exists('toSteamID'))
	{
		function toSteamID($id)	//https://gist.github.com/rannmann/49c1321b3239e00f442c
		{
			if(is_numeric($id) && strlen($id) >= 16)
			{
				$z = bcdiv(bcsub($id, '76561197960265728'), '2');
			}
			elseif (is_numeric($id))
			{
				$z = bcdiv($id, '2'); // Actually new User ID format
			}
			else
			{
				return $id; // We have no idea what this is, so just return it.
			}
			$y = bcmod($id, '2');
			return 'STEAM_0:' . $y . ':' . floor($z);
		}
	}
	
	if(!function_exists('EscapeQuotesAndBackslashes'))
	{
		function EscapeQuotesAndBackslashes($sText)
		{
			$sRtn = $sText;
			$sRtn = str_replace("'", "\'", $sRtn);
			$sRtn = str_replace("\\", "\\\\", $sRtn);
			return $sRtn;
		}
	}
	
	if(!function_exists('GenerateRandomString'))
	{
		function GenerateRandomString($length = 20)
		{
			$characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$charactersLength = strlen($characters);
			$randomString = '';
			for ($i = 0; $i < $length; $i++)
			{
				$randomString .= $characters[rand(0, $charactersLength - 1)];
			}
			return $randomString;
		}
	}
	
	if(!function_exists('CreatePageLinks'))
	{
		function CreatePageLinks($total_pages)
		{
			
		}
	}
	
	if(!function_exists('IfBlankSetZero'))
	{
		function IfBlankSetZero($value)
		{
			if($value == '')
			{
				return 0;
			}
			return $value;
		}
	}
	
	if(!function_exists('explode_to_console'))
	{
		function explode_to_console( $data )
		{
			$output = $data;
			if ( is_array( $output ) )
			{
				$output = implode( ',', $output);
			}
			echo "<script>console.log( 'Debug Objects: " . $output . "' );</script>";
		}
	}
	
	if(!function_exists('SQLAddWhereCol'))
	{
		function SQLAddWhereCol($inputcol, $paramname, $bFirstWhere = false, $bString = false)
		{
			$sReturn = "";
			if($bFirstWhere == true)
			{
				$sReturn = " WHERE ";
			}
			else
			{
				$sReturn = " AND ";
			}
			
			if(!empty($inputcol) && !empty($paramname))
			{
				if($bString == true)
				{
					$sReturn .= "(".$inputcol." LIKE :".$paramname.") ";
				}
				else
				{
					$sReturn .= "(".$inputcol." = :".$paramname.") ";
				}
			}
			return $sReturn;
		}
	}
	
	if(!function_exists('SQLAddWhereCol2'))
	{
		function SQLAddWhereCol2(&$variable, &$bFirstWhere, $inputcol, $paramname, $bStringInput = false, $bSkipCheck = false)
		{
			if(!isset($variable) || !isset($inputcol) || !isset($paramname))
			{
				return "";
			}
			else if(($inputcol == "") || ($paramname == ""))
			{
				return "";
			}
			else if(!$bSkipCheck)
			{
				if($variable == "")
				{
					return;
				}
			}
			
			$sReturn = "";
			if($bFirstWhere == true)
			{
				$sReturn = " WHERE ";
				$bFirstWhere = false;
			}
			else
			{
				$sReturn = " AND ";
			}
			
			if($bStringInput == true)
			{
				$sReturn .= "(".$inputcol." LIKE :".$paramname.") ";
			}
			else
			{
				$sReturn .= "(".$inputcol." = :".$paramname.") ";
			}
			
			return $sReturn;
		}
	}
	
	if(!function_exists('SQLBindParam'))
	{
		function SQLBindParam(&$stmt, &$variable, $paramname, $bStringInput = false, $bSkipCheck = false)
		{
			if(!isset($variable))
			{
				return;
			}
			else if(!$bSkipCheck)
			{
				if($variable == "")
				{
					return;
				}
			}
			
			if($bStringInput == true)
			{
				$stmt->bindValue(':'.$paramname, '%'.$variable.'%', PDO::PARAM_STR);
			}
			else
			{
				$stmt->bindValue(':'.$paramname, $variable, PDO::PARAM_INT);
			}
			return;
		}
	}
	
	if(!function_exists('DecodeParam'))
	{
		function DecodeParam(&$variable, $paramname, $defaultvalue = "", $bSanitize = false)
		{
			if(isset($_GET[$paramname]))
			{
				$variable = urldecode($_GET[$paramname]);
			}
			else
			{
				$variable = $defaultvalue;
			}
			
			if($bSanitize)
			{
				$variable = noHTML($variable);
			}

			return;
		}
	}
?>