<?php
	include("../settings.php");
	include("../../includes/togcoding/functions.php");
	
	if(isset($_GET["steamid"]))
	{
		$param_steamid = urldecode($_GET["steamid"]);
	}
	else
	{
		echo '<meta http-equiv="refresh" content="0; url=../playermatchstats/index.php" />';
	}
	
	$thispg = $transfer_protocol.'://' . $_SERVER['HTTP_HOST'] .strtok($_SERVER["REQUEST_URI"],'?');
	$thispg = str_replace("runquery.php", "index.php", $thispg);		//not needed if file used as an include. needed for ajax though

	$tblname = "togscrim_players";
	
	if(defined("SHOW_STEAM_LOGIN_PLYRSTATS"))
	{
		if(defined("REQUIRE_AUTH_PLYRSTATS"))
		{
			if($_SESSION['togscrim_admin'] != "ADMIN")
			{
				echo "<div class='title'><font class='fontred fontxl'><b><center><span class='blink_text'></br></br></br></br>You must be logged in as an admin to view this page!</span></center></b></font></div><br>";
				die;
			}
		}

		session_start();
	}
	
	/*function GetPlayerSteamName($steamid)
	{
		$xml = simplexml_load_file("https://steamcommunity.com/profiles/".GetSteamID64($steamid)."/?xml=1");	//link to user xml
		if(!empty($xml))
		{
			$username = $xml->steamID;
			echo $username;
		}
	}*/
	
	function GetAlts($sIPArr, $sAuthExpected, $sOrigAuthList, $conn, $tblname, $thispg)
	{
		$sAuthList = $sOrigAuthList;

		foreach($sIPArr as $sIP)
		{
			$query = "SELECT DISTINCT steamid FROM ".$tblname." WHERE lastclientip = :lastip AND steamid <> :steamid";
			$stmt = $conn->prepare($query);
			$stmt->bindValue(":lastip", $sIP["lastclientip"], PDO::PARAM_STR);
			$stmt->bindValue(":steamid", $sAuthExpected, PDO::PARAM_STR);
			$stmt->execute();
			$stmt->setFetchMode(PDO::FETCH_ASSOC);
			$aa_QueryRtn_AltIDs = $stmt->fetchAll();
			
			foreach($aa_QueryRtn_AltIDs as $sAltID)
			{
				if(strpos($sAuthList, $sAltID["steamid"]) === false)
				{
					$sAuthList = $sAuthList.'</br><a target="_self" href="'.$thispg.'?steamid='.$sAltID["steamid"].'" target="_blank">'.$sAltID["steamid"].'</a>';
					
					//check IPs of each alt for additional alts
					$query = 'SELECT DISTINCT lastclientip FROM '.$tblname.' WHERE steamid = :steamid';// ORDER BY match_id DESC';
					$stmt = $conn->prepare($query);
					$stmt->bindValue(":steamid", $sAltID["steamid"], PDO::PARAM_STR);
					$stmt->execute();
					$stmt->setFetchMode(PDO::FETCH_ASSOC);
					$queryrtn_altips = $stmt->fetchAll();
					
					$sAuthList = GetAlts($queryrtn_altips, $sAltID["steamid"], $sAuthList, $conn, $tblname, $thispg);
				}
			}
		}

		return $sAuthList;
	}

	try
	{
		//Get current steam info
		$test = "https://steamcommunity.com/profiles/".GetSteamID64($param_steamid)."/?xml=1";
		$player_steam_xml = simplexml_load_file("https://steamcommunity.com/profiles/".GetSteamID64($param_steamid)."/?xml=1");		//link to user xml

		if(!empty($player_steam_xml))
		{
			$avatar = $player_steam_xml->avatarFull;
			$currentname = $player_steam_xml->steamID;
			//var_dump($player_steam_xml);
		}
		
		echo '<p class="marginleft30 fontwhite fontbold font18">'.$currentname.'</p>';
		
		$conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
		$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		
		$query = 'SELECT SUM(`kills`) AS kills, SUM(`deaths`) AS deaths, SUM(`bombexplodes`) AS bombexplodes, SUM(`plants`) AS plants, SUM(`defuses`) AS defuses, SUM(`mvps`) AS mvps, SUM(`clutch_5v1`) AS clutch_5v1, SUM(`clutch_4v1`) AS clutch_4v1, SUM(`clutch_3v1`) AS clutch_3v1, SUM(`kills_5k`) AS kills_5k, SUM(`kills_4k`) AS kills_4k, SUM(`kills_3k`) AS kills_3k, SUM(`noscopes`) AS noscopes, SUM(`headshots`) AS headshots, SUM(`knives`) AS knives, SUM(`cummatchdmg`) AS cummatchdmg, SUM(`b_SubbedIn`) AS subbedin, SUM(`b_SubbedOut`) AS subbedout, SUM(`roundswon`) AS roundswon, SUM(`roundslost`) AS roundslost FROM togscrim_players WHERE steamid = :steamid GROUP BY steamid';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_main = $stmt->fetch();
		//var_dump($queryrtn_main);
		
		$query = 'SELECT COUNT(*) AS nummatches FROM '.$tblname.' WHERE steamid = :steamid GROUP BY steamid';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_matchcnt = $stmt->fetch();
		
		$query = 'SELECT DISTINCT lastnameused FROM '.$tblname.' WHERE steamid = :steamid';// ORDER BY match_id DESC';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_names = $stmt->fetchAll();
		
		$query = 'SELECT DISTINCT lastclientip FROM '.$tblname.' WHERE steamid = :steamid';// ORDER BY match_id DESC';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_ips = $stmt->fetchAll();
		
		//Check for alt IDs using IP match. After an alt is found, it checks all IPs under the alt for additional alts. Each additional alt found is recursively checked for more alts, etc.
		$sAuthList = $param_steamid;
		$sAuthList = GetAlts($queryrtn_ips, $param_steamid, $sAuthList, $conn, $tblname, $thispg);
		
		$query = 'SELECT * FROM '.$tblname.' WHERE steamid = :steamid';// ORDER BY match_id DESC';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_matches = $stmt->fetchAll();
		
		$query = 'SELECT * FROM togscrim_banlevel WHERE steamid = :steamid LIMIT 1';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_banlevel = $stmt->fetch();
		
		$query = "	SELECT *
					FROM
						(
							SELECT @rownum := @rownum + 1 AS row,
								@plyr_rank := IF(@prev_val!=rankpoints,@rownum,@plyr_rank) AS plyr_rank,
								steamid,
								@prev_val := rankpoints AS rankpoints
							FROM (
								SELECT steamid, ".RANKPOINTSQUERY." AS rankpoints 
								FROM `togscrim_players` 
								GROUP BY steamid 
							) A
							CROSS JOIN (SELECT @rownum := 0, @plyr_rank := 0, @prev_val := NULL) var
							ORDER BY rankpoints DESC
						) B
					WHERE steamid = :steamid";
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_rank = $stmt->fetch();

		/*$query = 'SELECT * FROM togscrim_kicks WHERE steamid = :steamid ORDER BY match_id DESC';
		$stmt = $conn->prepare($query);
		$stmt->bindValue(":steamid", $param_steamid, PDO::PARAM_STR);
		$stmt->execute();
		$stmt->setFetchMode(PDO::FETCH_ASSOC);
		$queryrtn_bans = $stmt->fetchAll();*/

		//echo "<script>alert(\"".$query."\");</script>";
		
		$frags = $queryrtn_main["kills"] + (3 * ($queryrtn_main["defuses"] + $queryrtn_main["bombexplodes"]));
		$totalrounds = $queryrtn_main["roundswon"] + $queryrtn_main["roundslost"];
		$totalmatches = $queryrtn_matchcnt["nummatches"];

		echo '<div class="floatleft marginleft30">';
			echo '<img src="'.$avatar.'" alt = "" border="2"></br>';
			$sProfileURL = 'https://steamcommunity.com/profiles/' .GetSteamID64($param_steamid);
			echo '<a target="_blank" class="headpoint4" href="'.$sProfileURL.'" target="_blank"><font class="fontbold"> > Steam Profile</font></a> </br>';
			echo '<span target="_blank" class="headpoint4"><font class="fontbold fontred font12">'.$param_steamid.'</font></span>';
		echo '</div>';
		
		$sBuffer = "";
		echo '<div class="floatleft fontleft marginleft10 margintop5">';
			echo '<span><font class="fontbold fontunderline">Player Names in Database:</font></br><font class="font11">(Most recent first)</font></br>&nbsp</span>';
			echo '<div class="altnameslist">';
				$bFirst = true;
				foreach($queryrtn_names as $sName)
				{
					/*if($bFirst == true)
					{
						$sBuffer .= $sName["lastnameused"];
						$bFirst = false;
					}
					else
					{
						$sBuffer .= '</br>'.$sName["lastnameused"];
					}*/
					$sBuffer .= $sName["lastnameused"].'</br>';		//this method is more efficient, but adds an extra line break at the end (doesnt matter here)
				}
				echo $sBuffer;
			echo '</div>';
		echo '</div>';

		$sBuffer = "";
		echo '<div class="floatleft fontleft marginleft50 margintop5">';
			echo '<span><font class="fontbold fontunderline">Player Steam ID List:</font></br></span>';
			echo '<div class="altiplist">';
				echo $sAuthList;
			echo '</div>';
		echo '</div>';
		
		$sBuffer = "";
		if($_SESSION['togscrim_admin'] == "ADMIN")
		{
			echo '<div class="floatleft fontleft marginleft90 margintop5">';
				echo '<span><font class="fontbold fontunderline">Player IP List:</font></br>(Most recent first)</br>&nbsp</span>';
				echo '<div class="altiplist">';
					$bFirst = true;
					foreach($queryrtn_ips as $sIP)
					{
						if($bFirst == true)
						{
							$sBuffer .= $sIP["lastclientip"];
							$bFirst = false;
						}
						else
						{
							$sBuffer .= '</br>'.$sIP["lastclientip"];
						}
					}
					echo $sBuffer;
				echo '</div>';
			echo '</div>';
		}
		
		echo '<br class="clearboth" /><div class="spacer25"></div><br class="clearboth" />';	//line break (clearboth resets floatleft) + spacer
		
		$sBuffer = "";
		echo '<div align="left" class="marginleft30">';
			echo '<table class="statstbl">';
				$sBuffer = '<tr><th><font class="font16 fontred fontbold">Player Rank:</font></th><td><font class="font14 fontred fontbold">'.$queryrtn_rank["plyr_rank"].'</font></td></tr>';
				$sBuffer .= '<tr><th><font class="font14">Rank Points:</font></th><td><font class="font14">'.$queryrtn_rank["rankpoints"].'</font></td></tr>';
			echo $sBuffer.'</table>';
		echo '</div>';
		
		echo '<br class="clearboth" /><div class="spacer25"></div><br class="clearboth" />';	//line break (clearboth resets floatleft) + spacer
		
		$sBuffer = "";
		echo '<div align="left" >';

			//Kill/Match Stats
			//echo '</br><a href="../playermatchstats/index.php?steamid='.$param_steamid.'" target="_blank" align="left" class="font16 fontbold">>> View Player Matches <<</a>';
			echo '<p class="headpoint4 marginleft30 fontbold fontunderline"align="left">Kill/Match Stats:</p>';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			echo '<table class="statstbl">';
				//$sBuffer = '<tr><th>Total Kills:</th><td>'.IfBlankSetZero($queryrtn_main["kills"]).'</td></tr>';
				//$sBuffer .= '<tr><th>Total Deaths:</th><td>'.IfBlankSetZero($queryrtn_main["deaths"]).'</td></tr>';
				if($queryrtn_main["deaths"] == 0)
				{
					$sBuffer .= '<tr><th>Frags/Death [FDR]:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>Kills/Death [KDR]:</th><td>N/A</td></tr>';
				}
				else
				{
					$sBuffer .= '<tr><th>Frags/Death [FDR]:</th><td>'.round(($frags/$queryrtn_main["deaths"]), 2).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$frags.' frags / '.$queryrtn_main["deaths"].' deaths)</td></tr>';
					$sBuffer .= '<tr><th>Kills/Death [KDR]:</th><td>'.round(($queryrtn_main["kills"]/$queryrtn_main["deaths"]), 2).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["kills"].' kills  /  '.$queryrtn_main["deaths"].' deaths)</td></tr>';
				}
				
				if($totalrounds == 0)
				{
					$sBuffer .= '<tr><th>Avg. Dmg/Round [ADR]:</th><td>N/A</td></tr>';
				}
				else
				{
					$sBuffer .= '<tr><th>Avg. Dmg/Round [ADR]:</th><td>'.round(($queryrtn_main["cummatchdmg"]/$totalrounds), 2).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["cummatchdmg"].'	cumm. damage / '.$totalrounds.' rounds)</td></tr>';
				}
				
				if($queryrtn_main["kills"] == 0)
				{
					$sBuffer .= '<tr><th>No Scope %:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>Head Shot %:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>Knives %:</th><td>N/A</td></tr>';
				}
				else
				{
					$sBuffer .= '<tr><th>No Scope %:</th><td>'.round(($queryrtn_main["noscopes"]/$queryrtn_main["kills"])*100, 2).'%&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["noscopes"].' no-scopes / '.$queryrtn_main["kills"].' kills)</td></tr>';
					$sBuffer .= '<tr><th>Head Shot %:</th><td>'.round(($queryrtn_main["headshots"]/$queryrtn_main["kills"])*100, 2).'%&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["headshots"].' headshots / '.$queryrtn_main["kills"].' kills)</td></tr>';
					$sBuffer .= '<tr><th>Knives %:</th><td>'.round(($queryrtn_main["knives"]/$queryrtn_main["kills"])*100, 2).'%&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["knives"].' knives / '.$queryrtn_main["kills"].' kills)</td></tr>';
				}
			echo $sBuffer.'</table>';
			
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			
			$sBuffer = "";
			echo 	'<table class="statstbl">';
						$sBuffer = '<tr><th>5v1 Clutches:</th><td>'.IfBlankSetZero($queryrtn_main["clutch_5v1"]).'</td></tr>';
						$sBuffer .= '<tr><th>4v1 Clutches:</th><td>'.IfBlankSetZero($queryrtn_main["clutch_4v1"]).'</td></tr>';
						$sBuffer .= '<tr><th>3v1 Clutches:</th><td>'.IfBlankSetZero($queryrtn_main["clutch_3v1"]).'</td></tr>';
						$sBuffer .= '<tr><th>5-Kill Rounds (Aces):</th><td>'.IfBlankSetZero($queryrtn_main["kills_5k"]).'</td></tr>';
						$sBuffer .= '<tr><th>4-Kill Rounds:</th><td>'.IfBlankSetZero($queryrtn_main["kills_4k"]).'</td></tr>';
						$sBuffer .= '<tr><th>3-Kill Rounds:</th><td>'.IfBlankSetZero($queryrtn_main["kills_3k"]).'</td></tr>';
					$sBuffer .= '</table>';
			echo $sBuffer;
			
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			
			$sBuffer = "";
			echo '<table class="statstbl">';
				$sBuffer = '<tr><th>Total Matches:</th><td>'.IfBlankSetZero($totalmatches).'</td></tr>';
				if($queryrtn_main["roundslost"] == 0)
				{
					$sBuffer .= '<tr><th>Rounds Won/Lost:</th><td>N/A</td></tr>';
				}
				else
				{
					$sBuffer .= '<tr><th>Rounds Won/Lost:</th><td>'.round(($queryrtn_main["roundswon"]/$queryrtn_main["roundslost"]), 2).'&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["roundswon"].' wins / '.$queryrtn_main["roundslost"].' losses; '.($queryrtn_main["roundswon"]+$queryrtn_main["roundslost"]).' rounds total)</td></tr>';
				}
				
				if($totalmatches == 0)
				{
					$sBuffer .= '<tr><th>Bomb Plants/Match:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>Bomb Explosions/Match:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>Bomb Defuses/Match:</th><td>N/A</td></tr>';
					$sBuffer .= '<tr><th>MVPs/Match:</th><td>N/A</td></tr>';
				}
				else
				{
					$sBuffer .= '<tr><th>Bomb Plants/Match:</th><td>'.round(($queryrtn_main["plants"]/$totalmatches), 2).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["plants"].' bomb plants / '.$totalmatches.' matches))</td></tr>';
					$sBuffer .= '<tr><th>Bomb Explosions/Match:</th><td>'.round(($queryrtn_main["bombexplodes"]/$totalmatches), 2).'&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["bombexplodes"].' bomb explosions / '.$totalmatches.' matches))</td></tr>';
					$sBuffer .= '<tr><th>Bomb Defuses/Match:</th><td>'.round(($queryrtn_main["defuses"]/$totalmatches), 2).'&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["defuses"].' bomb defuses / '.$totalmatches.' matches))</td></tr>';
					$sBuffer .= '<tr><th>MVPs/Match:</th><td>'.round(($queryrtn_main["mvps"]/$totalmatches), 2).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.$queryrtn_main["mvps"].' MVPs / '.$totalmatches.' matches))</td></tr>';
				}
			echo $sBuffer.'</table>';
			
			//echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			
			/*$sBuffer = "";
			echo '</br><p class="headpoint4 marginleft30 fontbold fontunderline" align="left">Matches:</p>';
			echo '<div class="fontgrey"><table class="darkTable">';
				$sBuffer = "";
				$bFirst = true;
				$sHeaders = '<tr>';
				foreach($queryrtn_matches as $arr)
				{
					$sBuffer .= '<tr>';
					foreach($arr as $key => $value)
					{
						//var_dump($key);
						//var_dump($value);
						if($bFirst == true)	//set up headers
						{
							$sHeaders .= '<th>'.$key.'</th>';
						}
						$sBuffer .= '<td>'.$value.'</td>';
					}
					$sBuffer .= '</tr>';
					$bFirst = false;
				}
				$sHeaders .= '</tr>';
			echo  $sHeaders.$sBuffer.'</table></div>';*/
		echo '</div>';
		
		echo '<br class="clearboth" /><div class="spacer25"></div><br class="clearboth" />';	//line break (clearboth resets floatleft) + spacer
		
		//Matches
		echo '<div align="left" >';
			echo '<span class="marginleft30 fontbold headpoint4"align="left"><font class="fontunderline">Player Matches:</font>&nbsp&nbsp&nbsp<a target="_self" class="font12" href="../playermatchstats/index.php?steamid='.$param_steamid.'" target="_blank" align="left" class="font16 fontbold">>> View Player Matches In Full Window <<</a></span></br></br>';
			echo '<div align="left" class="viewerwindow"width="1600px" height="auto">';
				echo '<iframe align="left" class="scale75" src="../playermatchstats/index.php?steamid='.$param_steamid.'&noheaders" width="1600px" height="300px"></iframe>';
			echo '</div>';
		echo '</div>';
		
		echo '<br class="clearboth" /><div class="spacer25"></div><br class="clearboth" />';	//line break (clearboth resets floatleft) + spacer
		
		//Bans
		echo '<div>';
			echo '<span class="marginleft30 fontbold headpoint4" align="left"><font class="fontunderline">Player Bans:</font>&nbsp&nbsp&nbsp<a target="_self" class="font12" href="../bans/index.php?steamid='.$param_steamid.'" target="_blank" align="left" class="font16 fontbold">>> View Player Bans In Full Window <<</a></span></br></br>';
			echo '<div align="left" class="displayinline" width="1350px" height="auto">';
				echo '<iframe align="left" class="marginleft50" src="../bans/index.php?steamid='.$param_steamid.'&noheaders" width="1350px" height="200px"></iframe>';
			echo '</div>';
		echo '</div>';
		
		echo '<br class="clearboth" /><div class="spacer25"></div><br class="clearboth" />';	//line break (clearboth resets floatleft) + spacer
		
		//Ban Level
		echo '<div>';
			echo '<span class="marginleft30 fontbold headpoint4" align="left"><font class="fontunderline">Ban Level:</font></span></br></br>';
			echo '<div align="left" class="displayinline" width="700px" height="auto">';
				echo '<iframe align="left" class="marginleft50" src="../banlevels/index.php?steamid='.$param_steamid.'&noheaders" width="700px" height="150px"></iframe>';
			echo '</div>';
		echo '</div>';
		/*echo '</br><div>';
			echo '<span class="marginleft30 fontbold headpoint4" align="left"><font class="fontunderline">Ban Level:</font></span>';
			echo '</br><iframe align="left" class="marginleft50" src="../banlevels/index.php?steamid='.$param_steamid.'&noheaders" width="700px" height="100px"></iframe>';
		echo '</div>';*/
		
		echo '<br class="clearboth" />';	//line break (clearboth resets floatleft)
		echo '<div class="spacer150"></div>';
		
		echo '<center><div class="clearboth">';
			echo '<p class="headpoint5">Page created by <a href="https://www.togcoding.com">That One Guy</a>.</p>';
		echo '</div></center>';
	}
	catch(PDOException $e)
	{
		echo "Error: " . $e->getMessage();
	}

	$conn = null;
?>